export { CID };
export function createWriter(): Writer;
export function encode({ roots, blocks }: {
    roots: API.Block[];
    blocks: Iterable<API.Block>;
}): Uint8Array;
export function decode(bytes: Uint8Array): Promise<{
    roots: API.Block[];
    blocks: API.Block[];
}>;
export type Block = API.Block | CARWriter.Block;
import { CID } from "multiformats/cid";
/**
 * @typedef {API.Block|CARWriter.Block} Block
 */
declare class Writer {
    /**
     * @param {Block[]} blocks
     * @param {number} byteLength
     */
    constructor(blocks?: Block[], byteLength?: number);
    written: Set<any>;
    blocks: Block[];
    byteLength: number;
    /**
     * @param {Block[]} blocks
     */
    write(...blocks: Block[]): Writer;
    /**
     * @param {API.Block[]} rootBlocks
     */
    flush(...rootBlocks: API.Block[]): Uint8Array;
}
import * as API from "./api.js";
import * as CARWriter from "@ipld/car/buffer-writer";
//# sourceMappingURL=car.d.ts.map