export * from "../api.js";
export function invoke<Capability extends API.UCAN.Capability<API.UCAN.Ability, `${string}:${string}`>>({ issuer, audience, proofs, capability }: API.IssuedInvocation<Capability>): API.IssuedInvocationView<Capability>;
export function batch<Invocations extends API.IssuedInvocation<API.UCAN.Capability<API.UCAN.Ability, `${string}:${string}`>>[]>(...invocations: Invocations): API.BatchView<Invocations>;
/**
 * @template {API.IssuedInvocation[]} Invocations
 * @implements {API.BatchView<Invocations>}
 */
export class Batch<Invocations extends API.IssuedInvocation<API.UCAN.Capability<API.UCAN.Ability, `${string}:${string}`>>[]> implements API.BatchView<Invocations> {
    /**
     * @param {Invocations} invocations
     * @param {Map<string, API.UCAN.View>} [delegations]
     */
    constructor(invocations: Invocations, delegations?: Map<string, API.UCAN.View<API.UCAN.Capability<API.UCAN.Ability, `${string}:${string}`>>> | undefined);
    invocations: Invocations;
    delegations: Map<string, API.UCAN.View<API.UCAN.Capability<API.UCAN.Ability, `${string}:${string}`>>>;
    /**
     * @template Service
     * @param {API.Connection<Service>} connection
     * @returns {Promise<API.ExecuteBatchInvocation<Invocations, Service>>}
     */
    execute<Service>(connection: API.Connection<Service>): Promise<API.ExecuteBatchInvocation<Invocations, Service>>;
}
/**
 * @template {API.Capability} Capability
 * @implements {API.IssuedInvocationView<Capability>}
 * @implements {API.IssuedInvocation<Capability>}
 */
export class IssuedInvocation<Capability extends API.UCAN.Capability<API.UCAN.Ability, `${string}:${string}`>> implements API.IssuedInvocationView<Capability>, API.IssuedInvocation<Capability> {
    /**
     * @param {object} data
     * @param {API.Issuer} data.issuer
     * @param {API.Agent} data.audience
     * @param {Capability} data.capability
     * @param {API.Proof[]} [data.proofs]
     */
    constructor({ issuer, audience, capability, proofs }: {
        issuer: API.Issuer;
        audience: API.Agent;
        capability: Capability;
        proofs?: API.Proof<API.UCAN.Capability<API.UCAN.Ability, `${string}:${string}`>>[] | undefined;
    });
    /** @readonly */
    readonly issuer: API.UCAN.Issuer<number>;
    /** @readonly */
    readonly audience: API.UCAN.Agent;
    /** @readonly */
    readonly proofs: API.Proof<API.UCAN.Capability<API.UCAN.Ability, `${string}:${string}`>>[];
    /** @readonly */
    readonly capability: Capability;
    /**
     * @template {API.InvocationService<Capability>} Service
     * @param {API.Connection<Service>} connection
     * @returns {Promise<API.ExecuteInvocation<Capability, Service>>}
     */
    execute<Service extends API.InvocationService<Capability, Capability["can"]>>(connection: API.Connection<Service>): Promise<API.ExecuteInvocation<Capability, Service, Capability["can"]>>;
}
export function execute<T, I extends API.ServiceInvocations<T>[] & API.IssuedInvocation<API.UCAN.Capability<API.UCAN.Ability, `${string}:${string}`>>[]>(batch: API.Batch<I>, connection: API.Connection<T>): Promise<API.ExecuteBatchInvocation<I, T>>;
import * as API from "../api.js";
//# sourceMappingURL=invoke.d.ts.map