export function create<Service>(options: API.Server<Service>): API.ServerView<Service>;
export function handle<Service, I extends API.ServiceInvocations<Service>[]>(handler: API.ServerView<Service>, request: API.Transport.HTTPRequest<API.Batch<I>>): Promise<API.Transport.HTTPResponse<API.ExecuteBatchInvocation<I, Service>>>;
export function execute<Service, I extends API.ServiceInvocations<Service>[]>({ service }: API.ServerView<Service>, { invocations }: API.Batch<I>): Promise<API.ExecuteBatchInvocation<I, Service>>;
export function invoke<I extends API.Invocation<API.UCAN.Capability<API.UCAN.Ability, `${string}:${string}`>>[], Service extends API.BatchInvocationService<I>>(service: Service, invocation: I[number]): Promise<any>;
import * as API from "./api.js";
/**
 * @template Service
 * @implements {API.ServerView<Service>}
 */
declare class Server<Service> implements API.ServerView<Service> {
    /**
     * @param {API.Server<Service>} options
     */
    constructor(options: API.Server<Service>);
    options: API.Server<Service>;
    decoder: API.Transport.RequestDecoder;
    encoder: API.Transport.ResponseEncoder;
    service: Service;
    /**
     * @template {API.ServiceInvocations<Service>[]} I
     * @param {API.Batch<I>} batch
     * @returns {API.Await<API.ExecuteBatchInvocation<I, Service>>}
     */
    execute<I extends API.ServiceInvocations<Service>[]>(batch: API.Batch<I>): API.Await<API.ExecuteBatchInvocation<I, Service>>;
    /**
     * @template {API.ServiceInvocations<Service>[]} I
     * @param {API.Transport.HTTPRequest<API.Batch<I>>} request
     * @returns {API.Await<API.Transport.HTTPResponse<API.ExecuteBatchInvocation<I, Service>>>}
     */
    request<I_1 extends API.ServiceInvocations<Service>[]>(request: API.Transport.HTTPRequest<API.Batch<I_1>>): API.Await<API.Transport.HTTPResponse<API.ExecuteBatchInvocation<I_1, Service>>>;
}
export {};
//# sourceMappingURL=server.d.ts.map